Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -762,604 +594,303 @@
         break;
     }
-    /////////////////////////
-    case DMA_CMD_TRT_LOCK:	// Waiting for the lock to modify Transaction Table
-    {
-        if ( r_alloc_trt_dma_fsm.read() == ALLOC_TRT_DMA_CMD ) 
-        {
-
-#if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm )
-{
-    std::cout << "  <IOB.DMA_CMD_TRT_LOCK> Check the TRT" << std::endl;
-}
-#endif
-            size_t 		wok_index = 0;
-            bool 		wok       = !m_transaction_tab_dma.full(wok_index);
-
-            if ( wok ) 	// TRT isn't full. Write the new transaction. 
-            {
-                r_dma_cmd_trt_index = (vci_trdid_t)wok_index;
-                r_dma_cmd_fsm       = DMA_CMD_TRT_SET;
-            } 
-            else 		// wait an empty entry in TRT
-            {
-                r_dma_cmd_rsp_erase_req = true;
-                r_dma_cmd_fsm       = DMA_CMD_TRT_WAIT;
-#if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm )
-{
-    std::cout << "  <IOB.DMA_CMD_TRT_LOCK> TRT is full. Going to TRT_WAIT state" << std::endl;
-}
-#endif
+    //////////////////////////
+    case DMA_CMD_FIFO_PUT_CMD:    // put a DMA transaction in DMA_CMD fifo	 
+                                  // if contig, VCI address must be incremented
+    {
+        if ( p_vci_tgt_iox.cmdval && m_dma_cmd_addr_fifo.wok() ) 
+        {
+            dma_cmd_fifo_put = true;
             
-#ifdef INSTRUMENTATION        
-m_cpt_trt_dma_full++;
-#endif
-            }
-        }
-        break;
-    }
-    ////////////////
-    case DMA_CMD_TRT_WAIT:	// release the lock protecting the transaction tab
-                            // waits that RSP erases an entry 
-    { 
-#ifdef INSTRUMENTATION        
-m_cpt_trt_dma_full_cost++;
-#endif
-        // DMA_RSP will notify an erase action by reseting this register
-        if(!r_dma_cmd_rsp_erase_req.read())
-        {
-            r_dma_cmd_fsm = DMA_CMD_TRT_LOCK; // take the lock again
-        }
-        break;
-    }
-    ////////////////////////
-    case DMA_CMD_TRT_SET:	// register a new transaction in TRT
-    {  
-        if ( r_alloc_trt_dma_fsm.read() == ALLOC_TRT_DMA_CMD ) 
-        {
-            if(r_miss_interrupt.read())
-            {
-                m_transaction_tab_dma.set(r_dma_cmd_trt_index.read(),
-                                      r_miss_srcid.read(), 
-                                      r_miss_trdid.read() );
-                r_dma_cmd_fsm = DMA_CMD_FIFO_MISS_PUT;
-            }
-            else
-            {
-                m_transaction_tab_dma.set(r_dma_cmd_trt_index.read(),
-                                          p_vci_tgt_dma.srcid.read(), 
-                                          p_vci_tgt_dma.trdid.read() );
-                r_dma_cmd_fsm = DMA_CMD_FIFO_PUT;
-            }
-#if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm )
-{
-    std::cout << "  <IOB.DMA_CMD_TRT_SET> Set a new entry in TRT" << std::endl;
-    if(r_miss_interrupt.read()) std::cout << " From the Network " << std::endl;
-    else std::cout << " From miss interruption" << std::endl;
-}
-#endif
-        }
-        break;
-    }  
-    ///////////////////////
-    case DMA_CMD_FIFO_PUT:	 
-    {
-        if ( p_vci_tgt_dma.cmdval && m_dma_cmd_addr_fifo.wok() ) 
-        {
-            dma_cmd_fifo_put = true;
-            //miss_unposted = false;
-            if(  p_vci_tgt_dma.contig )    r_dma_paddr = r_dma_paddr.read() + 4;
-            if(  p_vci_tgt_dma.eop )    r_dma_cmd_fsm = DMA_CMD_IDLE;
+            if ( p_vci_tgt_iox.contig.read() ) r_dma_cmd_paddr = r_dma_cmd_paddr.read() + 
+                                                          vci_param_ext::B;
+
+            if ( p_vci_tgt_iox.eop.read() )    r_dma_cmd_fsm   = DMA_CMD_IDLE;
            
 #if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm ) 
-{
-    std::cout << "  <IOB.DMA_CMD_FIFO_PUT> Push into cmd_fifo:" 
-              << " address = " << std::hex << r_dma_paddr.read()
-              << " srcid = " << std::dec << m_srcid_dma
-              << " trdid = " << r_dma_cmd_trt_index.read()
-              << " wdata = " << std::hex << p_vci_tgt_dma.wdata.read()
-              << " be = " << p_vci_tgt_dma.be.read()
-              << " contig = " << p_vci_tgt_dma.contig.read()
-              << " eop = " << std::dec << p_vci_tgt_dma.eop.read() 
-              << " plen = " << std::dec << p_vci_tgt_dma.plen.read() << std::endl;
-}
-#endif
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_CMD_FIFO_PUT_CMD> Push into DMA_CMD fifo:" 
+          << " address = " << std::hex << r_dma_cmd_paddr.read()
+          << " srcid = " << p_vci_tgt_iox.srcid.read()
+          << " trdid = " << p_vci_tgt_iox.trdid.read()
+          << " wdata = " << p_vci_tgt_iox.wdata.read()
+          << " be = " << p_vci_tgt_iox.be.read()
+          << " contig = " << p_vci_tgt_iox.contig.read()
+          << " eop = " << std::dec << p_vci_tgt_iox.eop.read() 
+          << " plen = " << std::dec << p_vci_tgt_iox.plen.read() << std::endl;
+#endif
+        }
+        break;
+    }
+    //////////////////////
+    case DMA_CMD_WAIT_EOP:	 // An error has been detected on the VCI DMA command
+                             // consume the VCI packet before sending the error response
+    {
+        if ( p_vci_tgt_iox.eop.read() )    r_dma_cmd_fsm   = DMA_CMD_FIFO_PUT_RSP;
+        break;
+    }
+    //////////////////////////
+    case DMA_CMD_FIFO_PUT_RSP:	 // try to put a response error in DMA_RSP fifo
+                                 // The FIFO is shared with DMA_RSP FSM 
+                                 // and we must we wait for allocation...
+    {
+        if ( r_alloc_fifo_dma_rsp_local.read() ) 
+        {
+            dma_rsp_fifo_put = true;
+
+            if( m_dma_rsp_data_fifo.wok() )
+            {
+
+#if DEBUG_DMA_CMD
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_CMD_FIFO_PUT_RSP> Put a response error to a DMA transaction." 
+          << std::endl;
+#endif
+                r_dma_cmd_fsm = DMA_CMD_IDLE;
+            }
         }
         break;
     }
     ///////////////////////
-    case DMA_CMD_FIFO_MISS_PUT:	 
-    {
-        if ( m_dma_cmd_addr_fifo.wok() ) 
-        {
-            dma_cmd_fifo_put    = true;
-            //miss_unposted       = true;
-            if( r_miss_contig.read() )    r_miss_paddr = r_miss_paddr.read() + 4;
-            
-            if( r_dma_cmd_count.read() == 1 ) 
+    case DMA_CMD_MISS_WAIT:  // waiting completion of a TLB miss
+                             // we must test a possible page fault error...   
+    {
+        if ( not r_dma_tlb_req.read() ) // TLB miss completed
+        {
+            if ( r_tlb_miss_error.read() )   // Error reported by TLB FSM
             {
-                r_tlb_dma_untreated = false;
-                r_miss_interrupt = false;
-                r_dma_cmd_fsm = r_dma_cmd_fsm_save.read();
+                r_iommu_etr     = MMU_READ_PT2_UNMAPPED; 
+                r_iommu_bvar    = r_dma_cmd_vaddr.read();
+                r_iommu_bad_id  = p_vci_tgt_iox.srcid.read();
+                r_dma_cmd_fsm   = DMA_CMD_FIFO_PUT_RSP;
             }
-            r_dma_cmd_count = r_dma_cmd_count.read() - 1;
-
-#if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm ) 
-{
-    std::cout << "  <IOB.DMA_CMD_FIFO_MISS_PUT> Push into cmd_fifo:" 
-              << " counter = " << std::hex << r_dma_cmd_count.read()
-              << " address = " << std::hex << r_miss_paddr.read()
-              << " srcid = " << std::dec << r_miss_srcid.read()
-              << " trdid = " << r_miss_trdid.read()
-              << " wdata = " << std::hex << r_miss_data
-              << " be = " << r_miss_be
-              << " plen = " << std::dec << r_miss_plen.read() << std::endl;
-}
-#endif
-        }
-        break;
-    }
-    ///////////////////
-    case DMA_CMD_TLB_MISS_WAIT: // to store the miss request there must be 
-                                // neither an ongoing request, nor a unposted finished request
-    {
-        // Treats an eventual request from TLB_MISS fsm 
-        // to send a command whose miss treatment is now finished
-        if ( r_tlb_dma_untreated.read() )
-        {
-            r_dma_cmd_fsm    = DMA_CMD_TRT_LOCK; //before posting we must update TRT
-            r_dma_cmd_fsm_save = DMA_CMD_TLB_MISS_WAIT;
-            r_miss_interrupt = true;
-            break;
-        }
-        // Error during miss treatment
-        else if (r_dma_tlb_error_req.read())
-        {
-            r_iommu_etr     = r_tlb_error_type.read(); 
-            r_iommu_bvar    = r_iotlb_vaddr.read();
-            r_iommu_bad_id  = r_miss_srcid.read();
-            // For DMA_RSP FSM
-            if(r_miss_cmd.read() == vci_param_io::CMD_WRITE) r_dma_error_type = WRITE_ERROR;
-            else r_dma_error_type = READ_ERROR;
-            r_dma_error_trdid   = r_miss_trdid.read(); 
-            r_dma_error_pktid   = r_miss_pktid.read(); 
- 
-            r_dma_tlb_error_req = false; 
-            r_dma_cmd_fsm   = DMA_CMD_ERROR;
-        }
-
-#ifdef INSTRUMENTATION        
-m_cost_iotlb_miss++;  // Now it represents misses' total blocking cost (not the treatment cost itself)
-#endif
-        else if (not r_dma_tlb_req.read())
-        {
-            r_dma_cmd_fsm   = DMA_CMD_TLB_MISS_STORE;
-            assert((r_dma_cmd_count.read() == 0) and "ERROR: TRT counter should be 0");
-        }
-        break;
-    }
-    ///////////////////
-    case DMA_CMD_TLB_MISS_STORE:
-    {
-        if ( p_vci_tgt_dma.cmdval.read()) 
-        {
-            if(r_dma_cmd_count.read() == 0)
+            else                            // No error
             {
-                r_miss_cmd = p_vci_tgt_dma.cmd.read();
-                r_miss_contig = p_vci_tgt_dma.contig.read();
-                r_miss_cons = p_vci_tgt_dma.cons.read();
-                r_miss_plen = p_vci_tgt_dma.plen.read();
-                r_miss_wrap = p_vci_tgt_dma.wrap.read();
-                r_miss_cfixed = p_vci_tgt_dma.cfixed.read();
-                r_miss_clen = p_vci_tgt_dma.clen.read();
-                r_miss_srcid = p_vci_tgt_dma.srcid.read();
-                r_miss_trdid = p_vci_tgt_dma.trdid.read();
-                r_miss_pktid = p_vci_tgt_dma.pktid.read();
-                
-//                r_dma_tlb_req   = true;
+                r_dma_cmd_fsm   = DMA_CMD_IDLE;
             }
-            
-            r_miss_data[r_dma_cmd_count.read()] = p_vci_tgt_dma.wdata.read();
-            r_miss_be[r_dma_cmd_count.read()] = p_vci_tgt_dma.be.read();
-            
-            r_dma_cmd_count = r_dma_cmd_count.read() + 1;
-            
-            if(  p_vci_tgt_dma.eop )  r_dma_cmd_fsm = DMA_CMD_IDLE;
-           
-#if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm ) 
-{
-    std::cout << "  <IOB.DMA_CMD_TLB_MISS_STORE> Storing VCI fields of command that originate the Miss:" 
-              << " counter = " << std::hex << r_dma_cmd_count.read()
-              << " address = " << std::hex << p_vci_tgt_dma.address.read()
-              << " srcid = " << std::dec << p_vci_tgt_dma.srcid.read()
-              << " trdid = " << p_vci_tgt_dma.trdid.read()
-              << " wdata = " << std::hex << p_vci_tgt_dma.wdata.read()
-              << " be = " << p_vci_tgt_dma.be.read()
-              << " plen = " << std::dec << p_vci_tgt_dma.plen.read() << std::endl;
-}
-#endif
-        }
-        break;
-    }
-    ///////////////////
-    case DMA_CMD_ERROR:
-    {
-        // Wait in case of pending request
-        // it isn't the case, generally
-        if(!r_dma_cmd_error_req.read())
-        { 
-            r_dma_cmd_error_req = true; 
-            r_dma_cmd_fsm       = DMA_CMD_IDLE;
-        }
-        break;
-    }
-    } // end switch DMA_CMD_FSM
-
-    /////////////////////////////////////////////////////////////////////
-    // The DMA_RSP_FSM controls the following ressources:
-    // - r_dma_rsp_fsm
-    // - r_dma_cmd_rsp_erase_req (reset) 
-    // - r_fma_error_req (reset)
-    // - 
+        }
+        break;
+    }
+    } // end switch DMA_CMD FSM
+
     //////////////////////////////////////////////////////////////////////////////
+    // The DMA_RSP_FSM handles the RAM responses to peripherals DMA transactions.
+    //////////////////////////////////////////////////////////////////////////////
+
     switch( r_dma_rsp_fsm.read() ) 
     {
-    /////////////////////
-    case DMA_RSP_IDLE:
+    //////////////////
+    case DMA_RSP_IDLE:  // waiting a response from RAM betwork
     {    	
-        // Interruption from DMA_CMD following an error
-        if(r_dma_cmd_error_req.read()) r_dma_rsp_fsm = DMA_RSP_FIFO_ERROR_PUT;
-        
-        if(p_vci_ini_dma.rspval.read()) 
+        if ( p_vci_ini_ram.rspval.read() ) 
 		{
-			r_dma_rsp_fsm = DMA_RSP_TRT_LOCK;
+			r_dma_rsp_fsm = DMA_RSP_FIFO_PUT;
 		}
 		break;
     }
-    /////////////////////
-    case DMA_RSP_TRT_LOCK:
-    {    	
-        if ( r_alloc_trt_dma_fsm.read() == ALLOC_TRT_DMA_RSP ) 
-        {
-            
-#if DEBUG_DMA_RSP
-if( m_debug_dma_rsp_fsm )
-{
-    std::cout << "  <IOB.DMA_RSP_TRT_LOCK> Erase entry" << std::endl;
-}
-#endif
-            uint32_t trdid_xram = p_vci_ini_dma.rtrdid.read(); 
-            
-            r_dma_rsrcid = (vci_srcid_t)m_transaction_tab_dma.readSrcid(trdid_xram);
-            r_dma_rtrdid = (vci_trdid_t)m_transaction_tab_dma.readTrdid(trdid_xram);
-            m_transaction_tab_dma.erase(trdid_xram);
-            if (r_dma_cmd_rsp_erase_req.read()) r_dma_cmd_rsp_erase_req = false;
-            r_dma_rsp_fsm       = DMA_RSP_FIFO_PUT;
-        }        
-		break;
-    }
-    //////////////////
+    //////////////////////
     case DMA_RSP_FIFO_PUT:
     {
-        if(p_vci_ini_dma.rspval.read() && m_dma_rsp_data_fifo.wok())
+        if(p_vci_ini_ram.rspval.read() and not r_alloc_fifo_dma_rsp_local.read() )
     	{
             dma_rsp_fifo_put = true;
-            if(p_vci_ini_dma.reop.read())   r_dma_rsp_fsm = DMA_RSP_IDLE;	
+
+            if(p_vci_ini_ram.reop.read())   r_dma_rsp_fsm = DMA_RSP_IDLE;	
 
 #if DEBUG_DMA_RSP
-if( m_debug_dma_rsp_fsm ) 
-{
-    std::cout << "  <IOB.DMA_RSP_FIFO_PUT> Push into rsp_fifo:" 
-              << " rsrcid = " << std::dec << r_dma_rsrcid.read()
-              << " rtrdid = " << r_dma_rtrdid.read()
-              << " rdata = " << std::hex << p_vci_ini_dma.rdata.read()
-    << std::endl;
-}
-#endif
-    			
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_RSP_FIFO_PUT> Push response into DMA_RSP fifo:" 
+          << " / rsrcid = " << std::hex << p_vci_ini_ram.rsrcid.read()
+          << " / rtrdid = " << p_vci_ini_ram.rtrdid.read()
+          << " / rdata = " << std::hex << p_vci_ini_ram.rdata.read()
+          << " / rerror = " << p_vci_ini_ram.rerror.read()
+          << " / reop = " << p_vci_ini_ram.reop.read() << std::endl;
+#endif
     	}
     	break;
     }
-    //////////////////
-    case DMA_RSP_FIFO_ERROR_PUT:
-    {
-        if(m_dma_rsp_data_fifo.wok())
-    	{
-            dma_rsp_fifo_put = true;
-            r_dma_rsp_fsm = DMA_RSP_IDLE;	
-
-#if DEBUG_DMA_RSP
-if( m_debug_dma_rsp_fsm ) 
-{
-    std::cout << "  <IOB.DMA_RSP_FIFO_ERROR_PUT> Push into rsp_fifo:" 
-              << " rsrcid = " << std::dec << r_iommu_bad_id.read()
-              << " rtrdid = " << r_dma_error_trdid.read()
-              << " rerror = " << r_dma_error_type.read()
-              << " rdata = " << std::hex << 0
-    << std::endl;
-}
-#endif
-    			
-    	}
-    	break;
-    }
     } // end switch DMA_RSP_FSM 
 
-    ////////////////////////////////////////////////////////////////////////////
-    // The ALLOC_TRT_DMA fsm allocates the access to the Transaction Table (m_transaction_tab_dma)
-    // with a round robin priority between 2 user FSMs :
-    // - DMA_CMD : to set a new entry
-    // - DMA_RSP : to read and erase an entry
-    // The ressource is always allocated.
-    ////////////////////////////////////////////////////////////////////////////
-    
-    switch ( r_alloc_trt_dma_fsm.read() ) 
-    {
-    ///////////////////
-    case ALLOC_TRT_DMA_CMD:
-    {
-        if ( r_dma_cmd_fsm.read() != DMA_CMD_TRT_LOCK ) 
-        {
-          if (r_dma_rsp_fsm.read() == DMA_RSP_TRT_LOCK) r_alloc_trt_dma_fsm = ALLOC_TRT_DMA_RSP;
-        }
-        break;
-    }
-    ///////////////////
-    case ALLOC_TRT_DMA_RSP:
-    {
-        if (r_dma_rsp_fsm.read() != DMA_RSP_TRT_LOCK) 
-        {
-            if (r_dma_cmd_fsm.read() == DMA_CMD_TRT_LOCK) r_alloc_trt_dma_fsm = ALLOC_TRT_DMA_CMD;
-        }
-        break;
-    }
-    } // end switch r_alloc_trt_dma_fsm
-    
-
-    ////////////////////////////////////////////////////////////////////////////
-    // The DMA_TLB_MISS FSM handles an IOTLB miss. It blocks the TGT_FSM.
-    // Input argument is:
-    // - r_iotlb_vaddr
-    // - r_dma_tlb_req (reset)
-    // - r_tlb_miss_init_req (set)
-    // - r_config_tlb_req (reset)
-    // - r_tlb_dma_untreated (set)
-    // 
-    // This fsm searchs the requested PTE on the  prefetch buffer.
-    // In case of miss,  it accesses the XRAM to find the missing TLB entry,
+    //////////////////////////////////////////////////////////////////////////////////
+    // The TLB FSM handles TLB miss request (from DMA_CMD FSM),
+    // and the PTE inval request (from CONFIG_CMD FSM).
+    // PTE inval request have highest priority. In case of TLB miss, 
+    // this fsm searchs the requested PTE on the prefetch buffer.
+    // In case of buffer miss,  it request the MISS_WTI FSM to access the memory.
     // It bypass the first level page table access if possible.
-    // It directly updates the iotlb, and writes into the 
-    // r_mmu_ins_* or r_mmu_data* error reporting registers.
+    // It reset the r_dma_tlb_req flip-flop to signal TLB miss completion.
+    // An unexpected, but possible page fault is signaled in r_tlb_miss_error flip_flop.
     ////////////////////////////////////////////////////////////////////////////////////
-    switch (r_dma_tlb_fsm.read())
-    {
-    case DMA_TLB_IDLE:
-    {
-        if(r_config_tlb_req)
-        {
-            r_config_tlb_req = false;
+
+    switch (r_tlb_fsm.read())
+    {
+    //////////////
+    case TLB_IDLE:   // In case of TLB miss request, chek the prefetch buffer first
+                     // PTE inval request are handled as unmaskable interrupts
+    {
+        if ( r_config_tlb_req ) // Request from CONFIG FSM for a PTE invalidation 
+        {
+            r_config_tlb_req      = false;
             r_waiting_transaction = false;
-            r_dma_tlb_fsm = DMA_TLB_INVAL_CHECK;
-        // Request from CONFIG FSM following an PTE invalidation signal by OS
-        }
-        // Miss in IOTLB
-        else if(r_dma_tlb_req.read())   
-        {
-        // Checking prefetch buffer, by the virtual address
-        if(!r_miss_buf_first_level)
-        {
-            if( r_miss_buf_valid &&
-                (r_miss_buf_vaddr_begin.read() == 
-                (r_iotlb_vaddr.read()& ~PTE2_LINE_OFFSET & ~K_PAGE_OFFSET_MASK)))
+            r_tlb_fsm = TLB_INVAL_CHECK;
+        }
+
+        else if ( r_dma_tlb_req.read() )   // request from DMA_CMD for a TLB Miss 
+        {
+            // Checking prefetch buffer
+            if( not r_tlb_buf_big_page )     // small page => PTE2
             {
-              // Hit
-                size_t pte_offset = (r_iotlb_vaddr.read()& PTE2_LINE_OFFSET)>>12; 
-              
-
-                uint32_t pte_flags = r_miss_buf_data[2*pte_offset];
-                uint32_t pte_ppn = r_miss_buf_data[2*pte_offset+1]; //because PTE2 is 2 words long
+                if( r_tlb_buf_valid &&         // Hit on prefetch buffer
+                    (r_tlb_buf_vaddr.read() == 
+                    (r_dma_cmd_vaddr.read()& ~PTE2_LINE_OFFSET & ~K_PAGE_OFFSET_MASK)))
+                {
+                    size_t   pte_offset = (r_dma_cmd_vaddr.read()& PTE2_LINE_OFFSET)>>12; 
+                    uint32_t pte_flags  = r_tlb_buf_data[2*pte_offset];
+                    uint32_t pte_ppn    = r_tlb_buf_data[2*pte_offset+1]; 
                 
-                // Bit valid checking
-                if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
-                {
-                    //must not occur!
-                    std::cout << "IOMMU ERROR : " << name() << " DMA_TLB_IDLE state" << std::endl
-                                  << "The Page Table entry ins't valid (unmapped)" << std::endl;
+                    // Bit valid checking
+                    if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
+                    {
+                        std::cout << "VCI_IO_BRIDGE ERROR : " << name() 
+                                  << " Page Table entry unmapped" << std::endl;
                        
-                    r_tlb_error_type          = MMU_READ_PT2_UNMAPPED;
-                    r_dma_tlb_error_req       = true;
-                    r_dma_tlb_req             = false;
-                        
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_IDLE> PTE2 Unmapped"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTE (first word) = " << pte_flags << std::endl;
-}
-#endif
-                    break; 
-                }
-
-                r_iotlb_pte_flags       = pte_flags; 
-                r_iotlb_pte_ppn         = pte_ppn;
-                r_dma_tlb_fsm           = DMA_TLB_PTE2_SELECT;
-                
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_IDLE> Hit on the prefetch buffer for PTE2:"
-              << " PTE_FLAGS = " << std::hex << pte_flags 
-              << " PTE_PPN = " << std::hex << pte_ppn << std::endl;
-}
-#endif
-                break;    
+                        r_tlb_miss_error = true;
+                        r_dma_tlb_req    = false;
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_IDLE> PTE2 Unmapped" << std::hex 
+          << " / paddr = " << r_tlb_paddr.read()
+          << " / PTE_FLAGS = " << pte_flags
+          << " / PTE_PPN = " << pte_ppn << std::endl;
+#endif
+                        break; 
+                    }
+
+                    // valid PTE2 : we must update the TLB
+                    r_tlb_pte_flags = pte_flags; 
+                    r_tlb_pte_ppn   = pte_ppn;
+                    r_tlb_fsm       = TLB_PTE2_SELECT;
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_IDLE> Hit on prefetch buffer: PTE2" << std::hex
+          << " / PTE_FLAGS = " << pte_flags 
+          << " / PTE_PPN = " << pte_ppn << std::endl;
+#endif
+                    break;    
+                }
             }
-        }
-        else    // First level entries on buffer. Unused if only small pages
-        {
-           if( r_miss_buf_valid &&
-              (r_miss_buf_vaddr_begin.read() == 
-               (r_iotlb_vaddr.read()& ~PTE1_LINE_OFFSET & ~M_PAGE_OFFSET_MASK ))) 
-            // The virtual address corresponds to one entry on the buffer line
+            else                             // big page => PTE1
             {
-              // Hit
-                size_t pte_offset = (r_iotlb_vaddr.read()& PTE1_LINE_OFFSET)>>21; 
-              
-                uint32_t pte_flags = r_miss_buf_data[pte_offset];
+                if( r_tlb_buf_valid &&         // Hit on prefetch buffer
+                    (r_tlb_buf_vaddr.read() == 
+                    (r_dma_cmd_vaddr.read()& ~PTE1_LINE_OFFSET & ~M_PAGE_OFFSET_MASK ))) 
+                {
+                    size_t   pte_offset = (r_dma_cmd_vaddr.read()& PTE1_LINE_OFFSET)>>21; 
+                    uint32_t pte_flags  = r_tlb_buf_data[pte_offset];
                             
-                // Bit valid checking
-                if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
-                {
-                    //must not occur!
-                    std::cout << "IOMMU ERROR " << name() << "DMA_TLB_IDLE state" << std::endl
-                                  << "The Page Table entry ins't valid (unmapped)" << std::endl;
+                    // Bit valid checking
+                    if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
+                    {
+                        std::cout << "VCI_IO_BRIDGE ERROR : " << name() 
+                                  << " Page Table entry unmapped" << std::endl;
                        
-                    r_tlb_error_type          = MMU_READ_PT1_UNMAPPED;
-                    r_dma_tlb_error_req       = true;
-                    r_dma_tlb_req             = false;
-                        
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_IDLE> First level entry Unmapped"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTE = " << pte_flags << std::endl;
-}
-#endif
-                    break; 
-                }
-                
-                if( pte_flags & PTE_T_MASK ) 	//  PTD : me must access PT2
-                {
-                    // register bypass
-                    r_iotlb.set_bypass( r_iotlb_vaddr.read(),
-                                      pte_flags & ((1 << (m_paddr_nbits-PAGE_K_NBITS)) - 1), 
-                                     0); //nline, unused 
-
-                    //&PTE2 = PTBA + IX2 * 8
-                    // ps: PAGE_K_NBITS corresponds also to the size of a second level page table
-                    r_iotlb_paddr = (paddr_t)(pte_flags & ((1<<(m_paddr_nbits-PAGE_K_NBITS))-1)) << PAGE_K_NBITS |
-                                  (paddr_t)(((r_iotlb_vaddr.read() & PTD_ID2_MASK) >> PAGE_K_NBITS) << 3);
-                    r_tlb_miss_init_req     = true;
-                    r_tlb_miss_type         = PTE2_MISS;
-                    r_dma_tlb_fsm           = DMA_TLB_WAIT_TRANSACTION;
+                        r_tlb_miss_error = true;
+                        r_dma_tlb_req    = false;
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_IDLE> PTE1 Unmapped" << std::hex 
+          << " / paddr = " << r_tlb_paddr.read()
+          << " / PTE = " << pte_flags << std::endl;
+#endif
+                        break; 
+                    }
+
+                    // valid PTE1 : we must update the TLB
+                    r_tlb_pte_flags = pte_flags;
+                    r_tlb_fsm       = TLB_PTE1_SELECT;
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_PTE1_GET> Hit on prefetch buffer: PTE1" << std::hex 
+          << " / paddr = " << r_tlb_paddr.read()
+          << std::hex << " / PTE1 = " << pte_flags << std::endl;
+#endif
+                    break;
+                }
+            }
+       
+            // prefetch buffer miss
+            r_tlb_fsm = TLB_MISS; 
+
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_IDLE> Miss on prefetch buffer"
+          << std::hex << " / vaddr = " << r_dma_cmd_vaddr.read() << std::endl;
+#endif
+        }
+        break;
+    }
+    //////////////
+    case TLB_MISS: // handling tlb miss
+    {
+        uint32_t	ptba = 0; 
+        bool		bypass;
+        vci_addr_t	pte_paddr;
+
 #ifdef INSTRUMENTATION
 m_cpt_iotlbmiss_transaction++;
 #endif
-
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_IDLE> Hit on prefetch, but it is a PTD.Search PTE2"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTD = " << pte_flags << std::endl;
-}
-#endif
-                }
-                else			//  PTE1 :  we must update the TLB
-                            //  Should not occur if working only with small pages
-                {
-                    r_iotlb_pte_flags   = pte_flags;
-                    r_dma_tlb_fsm  = DMA_TLB_PTE1_SELECT;
-
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_PTE1_GET> Success. Big page"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTE1 = " << pte_flags << std::endl;
-}
-#endif
-                }
-                break;
-            }
-        }
-       
-        r_dma_tlb_fsm = DMA_TLB_MISS; 
-
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_IDLE> Miss on prefetch."
-              << std::hex << " / vaddr = " << r_iotlb_vaddr.read() << std::endl;
-}
-#endif
-        }
-        break;
-    }
-    /////////////////////
-    case DMA_TLB_MISS: // handling all tlb miss
-    {
-        uint32_t	ptba = 0; //28 bits en TSAR
-        bool		bypass;
-        paddr_t		pte_paddr;
-
         // evaluate bypass in order to skip first level page table access
-        bypass = r_iotlb.get_bypass(r_iotlb_vaddr.read(), &ptba);
+        bypass = r_iotlb.get_bypass(r_dma_cmd_vaddr.read(), &ptba);
         
-        //Request to MISS_INIT_FSM to start transaction on Direct Network       
+        // Request MISS_WTI_FSM a transaction on INT Network 
         if ( not bypass )     // Read PTE1/PTD1 in XRAM
         {
-        // VOIR CONVENTION >> 13
-            pte_paddr = (paddr_t)((r_iommu_ptpr.read()) << (INDEX1_NBITS+2)) |
-                        (paddr_t)((r_iotlb_vaddr.read() >> PAGE_M_NBITS) << 2);
-            r_iotlb_paddr = pte_paddr;
+
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_MISS> Read PTE1/PTD1 in memory" << std::endl;
+#endif
+            pte_paddr = (vci_addr_t)((r_iommu_ptpr.read()) << (INDEX1_NBITS+2)) |
+                        (vci_addr_t)((r_dma_cmd_vaddr.read() >> PAGE_M_NBITS) << 2);
+            r_tlb_paddr = pte_paddr;
             
-            r_tlb_miss_init_req     = true;
-            r_tlb_miss_type         = PTE1_MISS;
-            r_dma_tlb_fsm           = DMA_TLB_WAIT_TRANSACTION;
-#ifdef INSTRUMENTATION
-m_cpt_iotlbmiss_transaction++;
-#endif
+            r_tlb_miss_req     = true;
+            r_tlb_miss_type    = PTE1_MISS;
+            r_tlb_fsm          = TLB_WAIT;
         }
         else                  // Read PTE2 in XRAM
         {
+
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_MISS> Read PTE2 in memory" << std::endl;
+#endif
             //&PTE2 = PTBA + IX2 * 8
-            pte_paddr = (paddr_t)ptba << PAGE_K_NBITS |
-                        (paddr_t)(r_iotlb_vaddr.read()&PTD_ID2_MASK)>>(PAGE_K_NBITS-3);
+            pte_paddr = (vci_addr_t)ptba << PAGE_K_NBITS |
+                        (vci_addr_t)(r_dma_cmd_vaddr.read()&PTD_ID2_MASK)>>(PAGE_K_NBITS-3);
             
-            r_iotlb_paddr = pte_paddr;
+            r_tlb_paddr = pte_paddr;
             
-            r_tlb_miss_init_req     = true;
-            r_tlb_miss_type         = PTE2_MISS;
-            r_dma_tlb_fsm           = DMA_TLB_WAIT_TRANSACTION;
-#ifdef INSTRUMENTATION
-m_cpt_iotlbmiss_transaction++;
-#endif
-        }
-
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_MISS> IOTLB miss";
-    std::cout << " / VADDR = " << std::hex << r_iotlb_vaddr.read()
-              << " / BYPASS = " << bypass 
-              << " / PTE_ADR = " << pte_paddr << std::endl;
-}
-#endif
-  
-        break;
-    }
-    /////////////////////////  
-    case DMA_TLB_PTE1_GET:	// Try to read a PT1 entry in the miss buffer
+            r_tlb_miss_req     = true;
+            r_tlb_miss_type    = PTE2_MISS;
+            r_tlb_fsm          = TLB_WAIT;
+        }
+
+        break;
+    }
+    //////////////////  
+    case TLB_PTE1_GET:	// Try to read a PT1 entry in the miss buffer
     {
         
         uint32_t  entry;
         
-        paddr_t line_number  = (paddr_t)((r_iotlb_paddr.read())&(CACHE_LINE_MASK));
-        size_t word_position = (size_t)( ((r_iotlb_paddr.read())&(~CACHE_LINE_MASK))>>2 );
+        vci_addr_t line_number  = (vci_addr_t)((r_tlb_paddr.read())&(CACHE_LINE_MASK));
+        size_t word_position = (size_t)( ((r_tlb_paddr.read())&(~CACHE_LINE_MASK))>>2 );
 
         // Hit test. Just to verify. 
         // Hit must happen, since we've just finished its' miss transaction
-        bool hit = (r_miss_buf_valid && (r_miss_buf_tag.read()== line_number) ); 
+        bool hit = (r_tlb_buf_valid && (r_tlb_buf_tag.read()== line_number) ); 
         assert(hit and "Error: No hit on prefetch buffer after Miss Transaction"); 
         
-        entry = r_miss_buf_data[word_position];
+        entry = r_tlb_buf_data[word_position];
             
         // Bit valid checking
